# traefik

[![Build Status](https://drone.autonomic.zone/api/badges/autonomic-cooperative/traefik/status.svg)](https://drone.autonomic.zone/autonomic-cooperative/traefik)

> https://docs.traefik.io/

> https://traefik.swarm.autonomic.zone

## Development

```bash
$ python3 -m venv .venv && source .venv/bin/activate
$ pip install -U pip setuptools docker-compose
$ docker-compose up
```

Traefik dashboard:

> http://traefik.localhost

Test application:

> http://whoami.localhost

Also available via (testing routing of proxy):

```bash
$ curl -H Host:whoami.localhost http://127.0.0.1
```

## Production

Our [drone.autonomic.zone](https://drone.autonomic.zone/autonomic-cooperative/traefik/) configuration automatically deploys.

To do it manually, you need to follow 3 steps.

1. Create the remote docker context locally.

```bash
$ cp .envrc.sample .envrc
$ direnv allow  # ensure password store works
$ make config
$ make context
$ docker context use swarm.autonomic.zone
```

2. Deploy the application to the remote docker context.

```bash
$ docker stack deploy \
  -c docker-compose.yml \
  -c docker-compose.production.yml \
  traefik
```

You can track logs via `docker service logs traefik_traefik`

3. Switch back to your local context.

```
$ docker context use default
```
